local abs, sin, cos, sqrt = math.abs, math.sin, math.cos, math.sqrt

function intersect(cx, cy, cr, sx, sy, sr, a1, a2)
	cx, cy = (cx - sx) / sr, (cy - sy) / sr
	local a = (a1 + a2) * .5
	local ar, ai = cos(a), sin(a)
	cx, cy = cx * ar + cy * ai, abs(cy * ar - cx * ai)
	a = abs(a - a1)
	ar, ai = cos(a), sin(a)
	cx, cy = ar * cx + ai * cy, ar * cy - ai * cx
	if cy <= 0 then
		return math.max(cy, math.sqrt(cx * cx + cy * cy) - 1) * sr - cr < 0
	else
		cx = cx - math.max(math.min(cx, 1), 0)
		return math.sqrt(cx * cx + cy * cy) * sr - cr < 0
	end
end

local im

function love.load()
	local w, h = love.graphics.getDimensions()
	im = love.image.newImageData(w, h)
	im:mapPixel(
		function (x, y)
			local d = intersect(x, y, 10, w/2, h/2, w*1/5, 0, math.pi*1.75)
			local c = d and 1 or 0
			return c, c, c, 1
		end
	)
	im = love.graphics.newImage(im)
end

function love.draw()
	local w, h = love.graphics.getDimensions()
	love.graphics.setColor(1, 1, 1)
	love.graphics.draw(im)
	love.graphics.setColor(.5, .5, .5, .3)
	love.graphics.rectangle("fill", w/2, h/2, w/2, h/2)
end
